/*
 *   Retrieve all the goodies on one file 
 */

#include <osbind.h>

	/* Structure used in finding info for a file */
typedef	struct {
		char		reserved[21];
		char		fattr;
		int			ftime;
		int			fdate;
		int			fsize;
		char		fname[14];
		} file_info ;

/* File area to hold data of functions */
file_info 	tempblock;		/* block where data should go */

file_info *get_file_info(filename)
	char		*filename;	/* file name only, no path */
{
	long	olddta;			/* Temp storage for DTA address */
	int		err;
	file_info	*info = &tempblock;

	olddta = Fgetdta();		/* save the current address */
	Fsetdta(info);			/* set to our address */

	err = Fsfirst(filename, 0);		/* get info on this file only */
	if (err)
		return(info = 0);

	Fsetdta(olddta);				/* restore the pointer */
	return(info);
}


file_info *get_file_info_next()
{
	long	olddta;			/* Temp storage for DTA address */
	int		err;
	file_info	*info = &tempblock;

	olddta = Fgetdta();		/* save the current address */
	Fsetdta(info);			/* set to our address */

	err = Fsnext();			/* get info on this file only */
	if (err)
		return(info = 0);

	Fsetdta(olddta);				/* restore the pointer */
	return(info);
}
