/***************************************************************************
 *
 * getstr - Get edited string
 *
 *   Usage:
 *
 *        integer = getstr(str_to_fill,int_maxlen,str_of_valid_chars);
 *
 *   Example:
 *
 *        int  length,getstr();
 *        char string[20];
 *        static string ok_chars[] = {"0123456789.-"};
 *        
 *        length = getstr(string,20,ok_chars);
 *
 *   Return:
 *
 *        length contains length of null-terminated string (not including
 *               the null itself).
 *        string contains the string entered.
 *
 *   Externals:
 *
 *        None.
 *
 *   Notes:
 *   
 *        The only thing this routine has over Cconrs() is the validity
 *        checking of valid_chars on a character-by-character basis...
 *        if the user hits a key that's not valid, it won't be echoed
 *        to the screen, cluing him (hopefully) that it's a bad char.
 *
 *        If the length of valid_chars is 0 (null string), all keyboard
 *        chars are considered valid. 
 *
 *        The maximum characters the user can enter is maxlen-1, insuring
 *        room to add the null terminator to the string.  DON'T PASS THIS
 *        ROUTINE A LENGTH OF ONE UNLESS YOU EXPECT TO RECEIVE A NULL
 *        STRING! (A length of 1 has the effect of making this a very
 *        fancy wait-for-carriage-return routine!).
 
 *        The following keys allow the user to edit the input, making it
 *        impossible to return the ASCII value of these keys.  These keys
 *        are ALWAYS valid, regardless of the content of valid_chars:
 *
 *             <RETURN> - Used to terminate input
 *             <DELETE> - Backspace and delete input chars
 *             <ESC>    - Clear input string and start over
 *
 *        Note that no attempt is made to deal with the cursor keys for 
 *        editing input -- they will be returned as data.
 *
 **************************************************************************/

int  getstr(string,maxlen,valid_chars)
register	int  	maxlen;
register	char 	string[]
					,valid_chars[];
{

			int  	ichar, index();
register	int		inctr, all_valid, done;
			char 	wchar;

all_valid = ! valid_chars[0];
inctr     = 0;
done      = 0;
maxlen--;

while (!done)
     {
     while (!Bconstat(2));    /*do nothing until key is hit*/
     wchar = ichar = Bconin(2) & 0x00FF;

     switch(ichar)
          {
          case 0x000D: /* RETURN ley */


               string[inctr] = 0x00;
               Bconout(2,10);Bconout(2,13);
               done++;
               break;

          case 0x0008: /* DELETE key */

               if (inctr)
                    {
                    Bconout(2,8); Bconout(2,32); Bconout(2,8);
                    inctr--;
                    }
               break;

          case 0x001B: /* ESC key */

               while (inctr)
                    {
                    Bconout(2,8); Bconout(2,32); Bconout(2,8);
                    inctr--;
                    }
               break;

          default:     /* any other key */

               if ((inctr < maxlen) && (all_valid || (instr(valid_chars,wchar))))
                    {
                    string[inctr++] = wchar;
                    Bconout(2,ichar);
                    }
               break;
          }
     }
return(inctr);
}

/* Return 1/0 indicating char is in string, or not. subfunction of getstr()*/

instr(str,chr)
register char *str,chr;
{
while(*str)
     if (chr == *str++)
          return(1);
return(0);
}

