/*********************************************************************/
/* LIBB definitions					   	  							 */
/*********************************************************************/

#ifndef DL_STANDARD
#define DL_STANDARD

#ifndef TRUE
#	define TRUE -1
#	define FALSE 0
#endif

#define NIL 0			/* Nil Pointer */

#define NO 0			/* "FALSE" */
#define YES 1			/* "TRUE" */

#define EOS '\0'			/* End of String marker */

#ifndef EOF
#	define EOF (-1)			/* End of File marker */
#endif

#define NEWLINE '\n'		/* Carriage Return */

#define	FAILURE	(-1)		/* Function failure return val */
#define SUCCESS	(0)		/* Function success return val */
#define	FOREVER	for(;;)		/* Infinite loop declaration   */

/*
	Used by function Dfree(). my version.
*/
typedef struct {
	long avail_clusters; 	 	/* no. of free clusters on drive */
	long total_clusters;		/* total no. of clusters on drive */
	long bytes_per_sector;  	/* no. of bytes in a sector */
	long sectors_per_cluster;   /* no. of sectors in a cluster */
} disk_info_1;

typedef struct {
	long total_bytes_free;		/* total bytes free on disk */
	long total_bytes_used;		/* total used bytes */
} disk_info_2;

/* Structure used in finding info for a file */
typedef struct {
	char		reserved[21];
	char		fattr;
	int			ftime;
	int			fdate;
	int			fsize;
	char		fname[14];
	} file_info;

#endif


/*********************************************************************/
/* Function definitions				   	  							 */
/*********************************************************************/

#ifndef DL_LIBB
#define DL_LIBB

#ifdef INCLUDE_GEMFAST
#include <gemfast.h>
#else
#include <obdefs.h>
#include <gemdefs.h>
#endif

#ifdef ANSI_PROTO
#define ARGS(x)			(x)
#else
#define ARGS(x)			()
#endif


/* get a string from tedinfo */
char 	*get_tedinfo ARGS( (OBJECT tree,
							int object,
							char *string) );

/* integer to ascii string */
char	*itoa ARGS( (int num, char *string, int comma) );
	#define NO_COMMA 0
	#define COMMA -1

char	*rplchr ();
int		set_tedinfo ();			/* set a string in tedinfo */
char	*strbld ();				/* cats more than one string */
char 	*strpadl ();			/* pad string on left */
char 	*strpadr ();			/* padd string on right */
char	*tolowers ();			/* convert a string to lower case */
char	*touppers ();			/* convert a string to upper case */
char 	*strsave ();			/* save a string */
char	*strtok ();				/* string token */
long	get_time_date ();		/* convert time and date to string
										"May 1, 1991    12:21:18" */
char	*strchr ();				/* string char first */
char	*strrchr ();			/* string char last */
char 	*substr ();				/* sub string a string up to 256 bytes */
file_info *get_file_info();		/* get info on a file */
file_info *get_file_info_next();	/* get info on next file if wildcards */

#undef ARGS

/*      MACRO Defines      */
#define		hide_mouse()		graf_mouse(M_OFF,0x0L)
#define		show_mouse()		graf_mouse(M_ON,0x0L)

#endif
