/**************************************************************************
 *
 * rplchr  --  Replace a character with any number of other characters.
 *             The characters are replaced in line of the string.
 *			   The largest source string this can manipulate is 256.	
 *
 *   Usage:
 *        Pass this routine a pointer to a string, a char to replace,
 *        the char to replace with, and the how many of that char to 
 *        replace with, (Normally this would be 1, but 0 would remove it
 *        and maybe 4 could b used to replace '\t' with spaces.),
 *		  and the number of items to replace. (-1 means all.)
 *           NOTE: If greater than 1 is used then the resultant
 *                  string will be larger than the original.
 *
 *			char *rplchr(string, char1, char2, number_chars, times);
 *				char	*string;		string to replace
 *				char	char1;			character to replace
 *				char	char2;			replace with this character
 *				int		number_chars;	number of characters on each replace
 *				int		times;			how many characters to replace
 *
 *	ex:		replace all leading spaces with *'s
 *				rplchr(string, ' ', '*', 1, -1)
 *
 *			relace all tabs with 4 spaces
 *				rplchr(string, '\t', ' ', 4, -1)
 *
 * Maintenance:
 *  09/07/90 - Original version. 
 *
 **************************************************************************/

char	*rplchr(string, char1, char2, number, times)

			char	*string;
register	char	char1;
register	char	char2;
			int		number, times;
			
{
			char	work_string[256];
register	char	*p1, *p2;
register	int		x;
	
	strcpy(work_string, string);
	
	if (times < 0)
		times = 256;
		
	p1 = string;
	p2 = work_string;
	
	while (*p2) {						/* while not '\0' */
		if (times && (*p2 == char1)) {	
			times--;					/* one less time */
			x = number;
			while(x--) 					/* while we have number */
				*p1++ = char2;			/* move the character */
			}
		else 
			*p1++ = *p2;				/* move the character */
		
		p2++;							/* next character */
		}
	*p1 = '\0';							/* terminate string */

	return (string);
}