/*------------------------------------------------------------------*/
/*
Function:    	set_clip

Syntax:			set_clip(id_handle,x,y,w,h)
			or	set_clip(id_handle, GRECT)
			
Remarks:  Sets the clipping rectangle for the window handle ID_HANDLE
			The rectangle dimensions can be given explicitly or passed
			as a GRECT structure.

Return value:	NONE

See Also: N/A

Example:

*/
/*------------------------------------------------------------------*/
/*
Function:    	set_clip_off

Syntax:			set_clip_off(id_handle)
			
Remarks:  Disables clipping for a window handle

Return value:	NONE

See Also: N/A

Example:

*/
/*------------------------------------------------------------------*/


#define CLIP_ON		1
#define CLIP_OFF	0


set_clip(handle, x,y,w,h)
	register	int	handle;
	register	int x,y;
				int w,h;
	{
		int x2, y2;
		
		x2 = x+w;
		y2 = y+h;
		
		vs_clip(handle, CLIP_ON, x, y, x2, y2 );
	}
			


set_clip_off(wind_handle)
	register	int	wind_handle;
	{
		vs_clip(wind_handle, CLIP_OFF, 0,0,0,0);
	}
