/*

 strbld  --  Rather than do a series of strcat together, this function
             takes multiple strings and concatenates then together.
			 The function returns a pointer to the final string.

		NOTE: This function requires at least four parameters. The 
			  resultant string, at least two strings to cat and a NULL.
			  If the minimum is all there is you should probably use
			  strcat instead. The NULL is required to tell it when to 
			  quit concatenating (NULL must be defined as 0L).

   Usage:
        Pass this routine a string that will hold the final string.
		If you wish anything in this final string to be included,
		pass it as an additional parameter.
			strbld(temp, temp, "hello ", NULL);

        Confused?  Check this out:

			 char string1[] = "Hello "
             char string2[] = "there, "
             char string3[] = "brian"
             char final[30]

		strbld(final, string1, string2, string3, NULL);
			or  strbld(final, string1, string2, string3, 0L);

        This sequence will yield the following:

             final = "Hello there, brian"


 Maintenance:
  12/27/90 - Original version. 

*/


#include <stdarg.h>

char *strbld(final)
char *final;
{
register va_list ap;
register char	 *x;

	va_start(ap, final);

	x=va_arg(ap, char *);
	strcpy(final, x);

	while (x=va_arg(ap, char *))
		strcat(final, x);

	return final;
}
