/**************************************************************************
 *
 * strpadl  --  Limit a string to a specific number of characters. Truncate
 *             if necessary or fill with pad_char on the left.
 *
 *				Returns pointer to string.
 *
 *   Usage:
 *        Pass this routine a pointer to a string and the number of
 *        characters you wish the string limited to. Be sure the string
 *        is delcared with enough size to hold an expanded string should
 *        the string need to expand. Should the function truncate the string
 *		  it will truncate the left of the string.
  *
 * strpadr  --  Limit a string to a specific number of characters. Truncate
 *             if necessary or fill with pad_char on the right.
 *
 *				Returns pointer to string.
 *
 *   Usage:
 *        Pass this routine a pointer to a string and the number of
 *        characters you wish the string limited to. Be sure the string
 *        is delcared with enough size to hold an expanded string should
 *        the string need to expand. Should the function need to truncate
 *		  the string it will truncate the right.
 *
 *
 * Maintenance:
 *  12/08/89 - Original version. 
 *
 **************************************************************************/
#include <strings.h>

char *strpadr(string, num, pad_char)
	register char *string;
	register int  num;
	register char pad_char;
{
	register int  len;

	len = strlen(string);
	
	/* do we truncate ? */
	if (len > num)
		string[num-1] = '\0';

	/* do we lengthen */
	if (len < num) { 
		while (len < num) 
			string[len++] = pad_char;
		string[len] = '\0';
		}

	return string;
}
		
/*   pad the left   */
char *strpadl(string, num, pad_char)
	register char *string;
	register int  num;
	register char pad_char;
{
	register int  x, y, blanks;
	register int  len;

	len = strlen(string);

	
	/* do we truncate ? */
	if (len > num) {
		x = len - num;
		strcpy(string, string+x);
		}

	/* do we lengthen */
	if (len < num) { 
		/* move string to rear */
		blanks = num - len;
		x = num - 1;
		y = len - 1;

		while (len--) 
			string[x--] = string[y--];

		/* fill with blanks */
		while (blanks)
			string[--blanks] = pad_char;

		/* set terminater */
		string[num] = '\0';
		}

	return string;
}
		
