
#include "xref.h"

/*****************************************************************************/
void module_map (modlist, title)
    struct cptr *modlist[];
char *title;
{
	register int i,
			j;
	struct cptr *pc,
 			*cp;

	NewPage ();
	underline_on ();
	fprintf (TempFile, title);
	underline_off ();

	cp = modlist[0];
	for (i = 0; i < nextf; i++) {
		cp = modlist[i];
		if (cp)	{
			fprintf (TempFile, "          %-12.12s ", fname[i]);
			j = 0;
			pc = cp;
			while (pc) {
				if (j > 2) {
					j = 0;
					fprintf (TempFile, "\n                              ");
					LineNumber++;
					if (LineNumber + 5 > PageEnd) {
						NewPage ();
						underline_on ();
						fprintf (TempFile, title);
						underline_off ();
						fprintf (TempFile, "\n                              ");
						LineNumber++;
						j = 0;
						}
					}
				fprintf (TempFile, "%-19.19s ", fname[pc->proc]);
				j++;
				pc = pc->next_ptr;
				}
	    /**
	     * MJC
	     * fprintf (TempFile, "\n\n");
	     * LineNumber++;
	     * LineNumber++;
	     */
			fprintf (TempFile, "\n");
			LineNumber++;
			}
		}
}

/*****************************************************************************/
void proc_map (sroutine, title )
int (*sroutine) ();
char *title;
{
	char ws[100];
	struct cptr *pc;
 	register int i,
				j;
 	int tproc;

	NewPage ();
	underline_on ();
	fprintf (TempFile, title);
	underline_off ();

	i = 0;
	do {
		tproc = TocIndex[i];
		if (tproc) {
			searchtree_index (proctree, ws, tproc);
			fprintf (TempFile, "      %-19.19s ", ws);
			j = 0;

			(*sroutine)(proctree, tproc, &pc);

			while (pc) {
				searchtree_index (proctree, ws, pc->proc);
				if (j > 2) {
					j = 0;
					fprintf (TempFile, "\n                          ");
					LineNumber++;

					if (LineNumber + 5 > PageEnd) {
						NewPage ();
						underline_on ();
						fprintf (TempFile, title);
						underline_off ();
						fprintf (TempFile, "\n                          ");
						LineNumber++;
						j = 0;
						}
					}

				fprintf (TempFile, "%-19.19s ", ws);
				j++;
				pc = pc->next_ptr;
				}
			fprintf (TempFile, "\n");
			LineNumber++;
			}
		else {
			fprintf (TempFile, "%s", Toc[i]);
			LineNumber += 2;
			}

		if (LineNumber + 5 > PageEnd) {
			NewPage ();
			underline_on ();
			fprintf (TempFile, title);
			underline_off ();
			j = 0;
			}

		i++;
		} while (i < TocCount);
}


/*****************************************************************************/
/*
 * strip out non-module calls (maybe use these later) build calls and
 * uses references
 */
void DumpCrossReference ()
{
	int i;

	PageNumber = -1;
	LineNumber = 0;
	TempFile = Ofile;			/* default output to standard out     */

	fprintf (stderr, "\n\n\tLinking Cross References.....\n\n");

	for (i = 0; i < num_call; i++) {
		proc_index = 0;
		searchtree_word (proctree, call_list[i].call, &proc_index);
		if (proc_index)	{
			store_call (proctree, call_list[i].proc);
			store_uses (proctree, proc_index, call_list[i].proc);
			store_mod_call (modcall, call_list[i].module, module_index);
			store_mod_call (moduse, module_index, call_list[i].module);
			}
		}

	fprintf (TempFile, "%s", printer->prt_init);

   /*
	* complete the call list first, do the module to module maps
	*/
	Name = "MODULE INTERACTION MAP";
	module_map (modcall, "          Module Name         Uses These Modules:\n\n");
	module_map (moduse, "          Module Name         Is Used by These Modules:\n\n");

   /*
    * dump procedure cross references will be in order to Table of Contents
    */

	Name = "PROCEDURE CROSS REFERENCE MAP";
    /**
	 * MJC
	 * proc_map (search_call, "          Procedure           Uses These Procedures:\n\n");
	 *  proc_map (search_use, "          Procedure Name      Is Used By These Procedures:\n\n");
	 */

	proc_map (search_call, "          Procedure           Uses These Procedures:\n");
	proc_map (search_use, "          Procedure Name      Is Used By These Procedures:\n");

	fflush (TempFile);		/* make sure everything is written out */
	BreakPage ();
}

/*****************************************************************************/
void Done ()
{
	if  (TempName)			/* if you created a file */
		unlink (TempName);	/* Delete temporary file */

	exit (0);				/* and leave the hard way */
}

/**************************************************************************/
void NewFile ()
{
	register int i,
			l;
	char temp[80];

	if (TocCount >= TOC_LEN) {
		fprintf (stderr, "%s: too many table of contents entries\n", ProgName);
		exit (1);
		}

	/* allocate some memory */
	if ((Toc[TocCount] = (char *) malloc (130)) == NULL)
		ReportMemoryError ();

	sprintf (Toc[TocCount], "\n     Module: %s%s%s", printer->prt_double_width_on, Name, printer->prt_normal);

	l = strlen (Name) * 3 + 6;		/* and findout how long it is */

	if (l < 64) {						/* if not to long */
		i = (64 - l) / 8;				/* calc. TAB increment */
		for (l = 0; l < i; ++l)			/* keep within 64 columns */
		strcat (Toc[TocCount], "\t");	/* and put some TAB's out */
		}

	file_stats (Name);

	if (header_flag); {				/** MJC ADD if (head_flag);  */
		if (! sectionflg) {
			/* Page #, Time & date */
			/**
			* MJC
			* sprintf (temp, "  Page %4d  (%s  %s)\n", PageNumber, file_date_buff, file_time_buff);
			*/
			sprintf (temp, "\n\n" );
			}
		else {
			/* Section, Time & Date */
			/**
			* MJC
			* sprintf (temp, "  Section %4d (%s  %s)\n", SectionNumber, file_date_buff, file_time_buff);
			*/
			sprintf (temp, "\n\n" );
			}
		}

	strcat (Toc[TocCount], temp);		/* copy to main buffer */
	++TocCount;							/* bump the entries */

	if (NumLines)						/* if numbering lines */
		Number = 1;						/* reset line number */

	/* not in comment or string */
	InComment = InString = InXComment = InXString = 0;
}

/*****************************************************************************/
int keycomp (elem1, elem2)
    char *elem1,
       *elem2;
{
    int i;

    i = strcmp (strcompress (elem1), strcompress (elem2));
    return (i);
}

/*****************************************************************************/
void write_xref (s)
    char *s;
{
	int i;

	if (cproc) {
		if (strlen (s = strcompress (s) ) )	{
			if (bsearch (s, ckeys, KEYSIZE, sizeof (ckey_type), keycomp) == NULL) {
				/* printf(xref,"%3d %3d %-20.20s\n",module_index,proc_index, s ); */
				if (num_call < MAX_XREF - 1) {
					call_list[num_call].module = module_index;
					call_list[num_call].proc = proc_index;
					call_list[num_call].call = strsave (s);
					num_call++;
					}
				}
			}
		}
}

/*****************************************************************************/
void AddToTableOfContents ()
{
	/* !!! cobine toc, tocpages, & tocindex into structure */
	register int l;
	register char *p;

	if (TocCount >= TOC_LEN) {
		fprintf (stderr, "%s: too many table of contents entries\n", ProgName);
		exit (1);
		}
	l = strlen (FunctionName);
	p = Toc[TocCount] = (char *) malloc (l + 1); /* !!! strsave */
	if (p == NULL)
		ReportMemoryError ();
	strcpy (p, FunctionName);
	TocPages[TocCount] = PageNumber;

	/* build a tree of procedure names and modules */
	if (cproc)
		free (cproc);
	cproc = strsave (root_name (FunctionName));
	if (p = strchr (cproc, '(')) {
		*p = ' ';
		while (*p && *p != ')')
			*p++ = ' ';
		if (*p == ')')
			*p = ' ';
		}

	cproc = strcompress (cproc);
	proctree = entertree (proctree, cproc, &last_proc_index, &proc_index);
	TocIndex[TocCount] = proc_index;
	TocCount++;
}

/****************************************************************************/
void DumpTableOfContents ()
{
    register int i,
        j,
        l;
    char *rn;

	if (TocCount == 0)			/* if there nothing to print */
		return;					/* then just return */

	if (WantSorted)				/* if you wanted it sorted by page number */
		SortTableOfContents ();	/* then we must sort it first */

	Name = "TABLE of CONTENTS";	/* give me a title for the page */

	PageNumber = -1;			/* Table of Contents pages are not numbered */
	LineNumber = 0;				/* and neither are the lines */
	TempFile = Ofile;			/* default output to standard out */

	fprintf (TempFile, "%s", printer->prt_init);

	NewPage ();					/* start out creating a new page */

	/* !!! check for long function names going off page and continue 
		next line */
	for (i = 0; i < TocCount; ++i) {
		if (Toc[i][0] == '\n') {
			if ((LineNumber + 5) > PageEnd)
				NewPage ();
			fprintf (TempFile, "%s", Toc[i]);
			LineNumber += 2;
			continue;
			} /* end of if */

		if (++LineNumber > PageEnd)	/* if going off end of page */
			NewPage ();				/* start a new page */

		rn = root_name (Toc[i]);
		l = ((rn - Toc[i]) < 20) ? 20 - (rn - Toc[i]) : 0;
		for (j = 0; j < l; j++)
			putc (' ', TempFile);
		fprintf (TempFile, "%s ", Toc[i]);

		l += strlen (Toc[i]);		/* length if function name with parms */

		for (j = l; j < 68; ++j)	/* put dots out to column 68 */
			putc ('.', TempFile);	/* put dots out to page num. in TOC */

		fprintf (TempFile, " %d\n", TocPages[i]);	/* print page number for function */
		} /* end of for */

	fflush (TempFile);				/* make sure everything is written out */
	BreakPage ();
}

/*****************************************************************************/
/*********************************************************/
/* Search the Table of Contents Entry and return a    */
/* pointer to the root name part of the entry (v3.2)  */
/*********************************************************/
char *root_name (ns)
    char *ns;
{
	char *p;

	p = ns;
	do {
		p++;
		} while ((*p != '(') && (*p));

	if (*p) {
		do {
			p--;
			} while ((!isnamechr (*p)) && (p > ns));

		do {
			p--;
			} while ((*p != ' ') && (p > ns));

		}

	if (*p == ' ')
		p++;
	if (*p == '*')
		p++;
	return (p);
}

/****************************************************************************/
/*
 * Sort Table of Contents by Funtion Name 
 */
void SortTableOfContents ()
{
    register int i,
        tempint;
    char *tempchar;
    int flag;

    /**
     * MJC
     * fprintf (stderr, "\nSorting Table of Contents.....");
     */
    fprintf (stderr, "\n\n\tSorting Table of Contents.....");

    do {
		flag = 0;	/* default to already sorted */

		for (i = 0; i < TocCount - 1; i++) {	/* look at them all */
			if (Toc[i][0] == '\n' || Toc[i + 1][0] == '\n')
				continue;				/* don't sort across file names */

			/* compare the strings */
			if (stricmp (root_name (Toc[i]), root_name (Toc[i + 1])) > 0) {
				tempchar = Toc[i];		/* copy to temp pointer */
				Toc[i] = Toc[i + 1];	/* swap the pointers in array */
				Toc[i + 1] = tempchar;	/* put the temp pointer back */
				tempint = TocPages[i];	/* grab the page number */
				TocPages[i] = TocPages[i + 1];	/* swap page numbers */
				TocPages[i + 1] = tempint;		/* put the temp page number back */
				tempint = TocIndex[i];
				TocIndex[i] = TocIndex[i + 1];
				TocIndex[i + 1] = tempint;
				flag = 1;				/* indicate you've swapped */
				} /* end of if */
			} /* end of for loop */
		} while (flag);	/* go until no more swaps can be made */
}

/****************************************************************************/
/*
 * Process string until you come out of COMMENT
 */
char *EndComment (p, flag)
	char *p;
	int *flag;
{
	char c;

	while ((c = *p++))					/* while there are chars to look at */
		if (c == '*' && *p == '/') {	/* and there a splat or a slash */
			*flag = 0;					/* say your not in the comment */
			break;						/* and leave the loop */
			}

	return (p - 1);						/* returning the new pointer addr. */
}

/*****************************************************************************/
/*
 * Process string until you come out of STRING
 */
char *EndString (p, flag)
	char *p;
	int *flag;
{
	register char c;

	while ((c = *p++) != 0)			/* while there are chars to look at */
		if (c == '\\') {			/* and forward slashs for next line */
			continue;	    /* means "Just read on McDuck" */
			}
		else
			if (c == '"') {			/* if you found the ending quote */
				*flag = 0;			/* say your not in a string anymore */
				break;				/* and leave the loop */
				}

	return (p - 1);					/* returning the new pointer addr.  */
}

/****************************************************************************/
/*
 * This is the function `char *expand().'  This function takes as an argument
 * a NULL terminated string and replaces all occurances
 * of the tab character with 8 (eight) spaces.  The function returns a pointer
 * to a static string which is overwritten on
 * subsequent calls. 
 *     (Changed to use the tab definitions not 8 spaces)
 */
/****************************************************************************/
char *expand (string)
	char *string;
{
	int count;
	static char retstr[MAX_S];

	for (count = 0; count < MAX_S; retstr[count++] = NULL)
		;

	for (count = 0; *string != NULL; count++, string++) {
		if (*string == '\t') {
			retstr[count] = ' ';
			while (TabDef[count] != 'T')	/* while (((count + 1) % 8) != 0) */
				retstr[++count] = ' ';
			}
		else
			retstr[count] = *string;
		}
	retstr[count] = NULL;
	return (retstr);
}

/****************************************************************************/
/*
 * is character "a" a member of string "b"
 */
int Cmemb (a, b)
	char a,
	*b;
{
	while (*b)				/* go until the null character */

	if (a == *b++)			/* looking for the character and bumping the pointer */
		return (1);			/* return 1 if its found */
 
	return ((!a) ? 1 : 0);	/* return 0 if "a" was a non-zero character */
}

/****************************************************************************/
StarDot (file_string)
    char *file_string;
{
    unsigned long int total_file_size = 0;
    unsigned long int total_disk_free = 0;
    int done = FALSE;
    int i = 0;
	file_info *fblock;

    file_string += 2;		    /* bump past -A switch */

    /* Attempt 1st file read */
    if ((fblock = get_file_info(file_string)) == NULL) {
		fprintf (stderr, "No Files Found\n");
		exit (1);
		}

    while (!done && i < N_FILES) {    /* go until done or to many files  */
		fname[i++] = strsave (fblock->fname);   /* copy names into array	*/
		total_file_size += fblock->fsize;		/* keep running total of filesizes */
		if (!(fblock = get_file_info_next()) == NULL);	/* read next availables file info */
			done = TRUE;				/* exit loop if NULL */
		}

    if (i == N_FILES)
		fprintf (stderr, "Printing ONLY 1st %d Files\n", N_FILES);

 	 /* get bytes free on disk */
	disk_information(&disk_space_1, &disk_space_2, 0);

	if ((total_file_size * 2) >= disk_space_2.total_bytes_free) {
		fprintf (stderr, "Insufficient Disk Space!\nMinimum of %lu bytes needed.\n\nYou Have %lu bytes free\n", total_file_size * 2, total_disk_free);
		exit (1);
		}
    return (i);    /* return new number of files */
}

/*****************************************************************************/
void ReportMemoryError ()
{
	fprintf (stderr, "\nMemory Allocation Error\n");

	if (TempName) {				/* if there is a file to work on */
		EndTempFile ();			/* Make sure file is closed */
		unlink (TempName);		/* Delete temporary file */
		}
	exit (1);
}

/*****************************************************************************/
void ReadHeaderFile (header_file)
    char *header_file;
{
    extern char header_buffer[MAX_HDR_BYTES];
    extern int header_lines;
    int ch;
    int i = 0;
    int x = 0;
    char *string;

    /*
     * strip the "-h" from the string
     */
    header_file += 2;
    if ((Hfile = fopen (header_file, "r")) == NULL)
    {
	fprintf (stderr, "Can't Open Header File %s\n", header_file);
	exit (1);
    }
    else
    {
    /*
     * read entire file that is up to MAX_HDR_BYTES characters long
     */
	while ((ch = fgetc (Hfile)) != EOF)
	{
	    header_buffer[i++] = (unsigned char) ch;
	    if (i < MAX_HDR_BYTES)
		continue;
	    else
		break;
	}
	/*
	 * terminate buffer
	 */
	header_buffer[i] = '\0';

	/*
	 * and close the file
	 */
	fclose (Hfile);

	for (x = 0, string = header_buffer; x <= i; x++)
	{
	    /*
	     * count number of line feeds
	     */
	    if (*string++ == '\n')
		/*
		 * tell the NewPage Function
		 */
		header_lines++;
	}
    }
}


/*****************************************************************************
    This routine is executed when the CONTROL-BREAK key combination is hit
    { Not in Version 3.2 with Microsoft v5.1 but left in for others}
*****************************************************************************/
c_break ()
{
	fprintf (stderr, "Control-Break hit.  Program aborting ...\n");

	if (TempName) {			/* if you created a file */
		EndTempFile ();		/* Make sure file is closed */
		unlink (TempName);	/* Delete temporary file */
		}

	return (0);				/* ABORT sequence */
}

/*****************************************************************************/
void file_stats (filename)
    char *filename;
{
	file_info *fblock;

	fblock = get_file_info(filename);		/* read data into structure */

/* ------------------- Show date in standard format -------------------- */

	sprintf (file_date_buff, "%02d-%02d-%02d",
			((fblock->fdate >> 5) & 0x0f),    /* month     */
			(fblock->fdate & 0x1f),           /* day       */
			((fblock->fdate >> 9) + 80));	/* year      */

/* -----------------   Show time in 12 Hour Format   ------------------- */
	if ((fblock->ftime >> 0x0b) <= 12) {
		sprintf (file_time_buff, "%02d:%02d",
				(fblock->ftime >> 0x0b),
				((fblock->ftime >> 5) & 0x3f));	/* minutes   */
		}
	else {
		sprintf (file_time_buff, "%02d:%02d",
				((fblock->ftime >> 0x0b) - 12),
				((fblock->ftime >> 5) & 0x3f));	/* minutes   */
		}
/* ------------------     Decipher whether its AM or PM  ---------------- */
	if ((fblock->ftime >> 0x0b) < 12)
		strcat (file_time_buff, " am");				/* for AM */
	else
		strcat (file_time_buff, " pm");				/* for PM */
}

/*****************************************************************************/
int printer_code_init ()
/*
 * routine to initialize and select printer codes - called from initialize
 */
{
	printer = &(print_code[nprinter]);
	return (1);
}

/*****************************************************************************/
void normal_print ()
{
	fprintf (TempFile, "%s", printer->prt_normal);
}

/*****************************************************************************/
void emphasized_print_on ()
{
	fprintf (TempFile, "%s", printer->prt_emphasize_on);
}

/*****************************************************************************/
void emphasized_print_off ()
{
	fprintf (TempFile, "%s", printer->prt_emphasize_off);
}


/*****************************************************************************/
void print_double_width ()
{
	fprintf (TempFile, "%s", printer->prt_double_width_on);
}

/*****************************************************************************/
void compressed_print ()
{
	fprintf (TempFile, "%s", printer->prt_compress);
}

/*****************************************************************************/
void new_print_page ()
{
	fprintf (TempFile, "%s", printer->prt_new_page);
}

/*****************************************************************************/
void underline_on ()
{
	fprintf (TempFile, "%s", printer->prt_underline_on);
}


/*****************************************************************************/
void underline_off ()
{
	fprintf (TempFile, "%s", printer->prt_underline_off);
}

/*****************************************************************************/
void pspace (ns)
	int ns;
{
	register int i;

	for (i = 0; i < ns; i++)
		fprintf (TempFile, " ");
}

/*****************************************************************************/
char *strupper (str)
	char *str;
{
	register int c;
	register char *s = str;

	while (c = *s)
		*s++ = (char) toupper (c);
	return (str);
}


/*****************************************************************************/
/*
 * utility to strip leading and trailing blanks from a null terminated string
 */
char *strcompress (str)
	char *str;
{
	register char *s;

	s = str + strlen (str);
	*s--;
	while (*s == ' ')
		s--;
	*++s = '\0';
	while (*str == ' ')
		str++;
	return (str);
}
