#include "xref.h"


/*****************************************************************************/
/*
 * Process New Function
 */
void NewFunction ()
{
    register int i;

	if (LineNumber > (PageLength * 3 / 4))		/* 49.5 lines */
		NewPage ();
	else {
		if (!OnePerPage) {						/* if mult. functions per page */
			for (i = 0; i < (PageLength / 7); ++i)
				putc ('\n', TempFile);			/* add extra lines */
		
			LineNumber += PageLength / 7;		/* set line counter also */
			}	
		else	/* otherwise its 1 func. per page */
			NewPage ();
		}
}

/*****************************************************************************/
LooksLikeFunction (s)
    char *s;
{
    char *p;
    char *save;
    int nosl,
        nolp,
        norp,
        flg;
    int AddOne = 0;

	if (InComment || InString)		/* if you're in a comment or in a string */
		return (0);					/* just leave and return 0 */

	p = FunctionName;				/* assign pointer to function name string */
	save = s;						/* save address of string */
	nosl = nolp = norp = 0;			/* no left or right paren or no slash */
	flg = 1;

	for (; *s && flg; s++) {		/* go until end of string or flag is set */
		switch (*s)	{				/* switch on each character in string */
			case '(':				/* is it a left paren? */
				if (!nolp) {		/* if no left paren already */
					nolp = 1;		/* flag that you've got one */
										/* 3/4/87 added following line to include ARGS in TOC */
					*p++ = *s;		/* move byte of ARG into function buffer */
					}
				else
					return (0);		/* or return if you've already had one */
				break;

			case ')':				/* is it a right paren? */
				if (nolp && !norp) {	/* if already a left paren and no right yet */
					norp = 1;		/* flag that you've got a right paren */
										/* 3/4/87 added following line to include ARGS in TOC */
					*p++ = *s;		/* move byte of ARG into function buffer */
					}
				else
					return (0);		/* or return if conditions were'nt right */
				break;

			default:				/* everything comes thru here */
				if (!nolp) {		/* if no left paren yet */
					if (isiechr (*s)) {		/* is it alpha,digit,'_*\t\n'? */
						if (isidchr (*s))	/* is it alpha,digit,'_' or ' '? */
							*p++ = *s;		/* if it is store the byte for TOC */
						else
							p = FunctionName;	/* start over if '*\t\n' & nolp */
						break;
						}
					else
						return (0);			/* return if conditions weren't right */
					}

				if (!norp) {					/* if no right paren yet */
					if (isiechr (*s) || *s == ',') {	/* is it alpha,digit,'_ *\t\n'? */
						/* 3/4/87 added following line to include ARGS in TOC */
						*p++ = *s;			/* move byte of ARG in function buffer */
						break;
						}
					else
						return (0);			/* return if conditions weren't right */
					}

				if (Cmemb (*s, " \t\n\r") && !nosl)	/* is it ' \t\n\r' or no slash yet */
					if (*s == '/' && !nosl) {		/* is it a '/' and no slash yet */
						nosl = 1;					/* flag that you've got one */
						break;
						}

				if (*s == '*' && nosl) {	/* if its '*' & you got a slash already */
					flg = 0;				/* set flag to abort loop */
					break;
					}

				return (0);					/* return if conditions not right */

				}   /* end of switch */
			}    /* end of for loop */

		if (nolp != 1)				/* return if no left paren found */
			return (0);

		*p = '\0';					/* else terminate function buffer */

		if (NumLines) {				/* if line numbering enabled */

			/*
			 * the following code indents the Funtion Names with Line Numbering
			 * It is removed in favor of inserting a blank line
			 */
		 	/***
			 *   sprintf (Digits,"[%4d]  ", Number);
			 *   Cnt = strlen(Digits) + AddOne;
			 *   while (Cnt-- > 0)
			 *       putc (' ', TempFile);
			 *   AddOne = 0;
			 ***/
			putc ('\n', TempFile);
			LineNumber++;
			}

		/* This will cause the function name part of the line to be double striken. */
		if (double_strike == 3) {
			while (*save && *save != '(')	/* double strike up to func name */
				putc (*save++, TempFile);

			putc ('\r', TempFile);			/* use CR for doublestrike */
			}
		return (1);
}

/*************************************************************************/
int CrossRefFunction (s)
    char *s;
{
    char *p,
        c;
    char refname[100];

	p = refname;			/* assign pointer to function name string */

	for (; *s; s++) {
		if (InXComment)
			s = EndComment (s, &InXComment);
		if (InXString)
			s = EndString (s, &InXString);

		switch (*s) {
			case '\'' :
				while ((c = *(++s)) && c != '\'')
					;
				if (*(s + 1) == '\'')
					s++;			/* special case */
				break;

			case '"' :
				InXString = 1;
				while ((c = *(++s)) && c != '\"')
					;
				if (c == '\"')
					InXString = 0;
				break;

			case '/' :
				if (*(s + 1) == '*') {
					InXComment = 1;
					s++;
					/***
					 *	while( (c = *s++) ) {
					 *		if( c == '*' && *s == '/' ) {
					 *			InXComment = 0;
					 *			break;
					 *			}
					 *		}
					 *	s--;
					 ***/
					}
				break;

			case '(' :
				*p = '\0';
				write_xref (refname);
				p = refname;
				break;

			case '|':
			case '^':
			case '!':
			case '.':
			case '+':
			case '-':
			case '%':
			case '*':
			case '&':
			case '?':
			case '[':
			case ']':
			case '<':
			case '>':
			case ';':
			case ':':
			case '=':
			case ',':
			case ')':
				p = refname;		/* start name over */
				break;

		default:
			if (isiechr (*s)) {		/* is it alpha,digit,'_*\t\n'? */
				if (isidchr (*s))	/* is it alpha,digit,'_' or ' '? */
					*p++ = *s;		/* if it is store the byte for TOC */
				else
					p = refname;	/* start over if '*\t\n' & nolp */
				break;
				}
		}			/* end of switch */
	}				/* end of for loop */
	return (1);
}
