#include "xref.h"
/*****************************************************************************/
/*
 * Process Incoming File
 */
void List ()
{
	register int bp;
	char buffer[257];
	char *p;

	if (sectionflg) {					/* if by section */
		PageNumber = 1;					/* start the page number at 1 */
		LineNumber = 0;					/* Lines reset each time */
		}

	BreakPage ();						/* Form Feed */

	NewPage ();							/* bump page & output header */
    NewFile ();

	bp = Braces = 0;					/* no begin page and braces */

    /* read a line upto 256 bytes */
	while (fgets (buffer, 256, File) != NULL) {
		Rs (buffer);					/* Remove Trailing Spaces */

		if (bp)							/* if beginning page */
			NewFunction ();				/* setup for new function */

		if ((LineNumber + 1) > PageEnd)	/* if going past page end */
			NewPage ();					/* start a new page */

		/* no braces and a function */
		if (!Braces && LooksLikeFunction (buffer))
			AddToTableOfContents ();	/* then add to TOC */
		else
			CrossRefFunction (buffer);	/* Cross ref the function */

		bp = PutLine (buffer);
		LineNumber++;
		}

		if (sectionflg)					/* if by sections */
			SectionNumber++;			/* Bump to next Section */
}

/*****************************************************************************/
/*
 * Process New Page
 */
void NewPage ()
{
	if  (LineNumber > HEADER_SIZE) {
		if  (PageNumber >= 0) {
			PageNumber++;				/* bump Page Number */
			}

		BreakPage ();					/* form feed if allowed */
		LineNumber = 0;					/* set flag for a header */
		}

	if (LineNumber == 0)				/* Each new page */
		PutHeader ();					/* Outputs a Header */
}

/*****************************************************************************/
/*
 * Process Page Break
 */
void BreakPage ()
{
	if  (header_flag)			/* if its allowed send a FORM FEED */
		new_print_page ();
}

/****************************************************************************/
/*
 * strip trailing blanks from string
 */
char *Rs (s)
    char s[];

{
	int n;

	for (n = strlen (s) - 1; n >= 0 && iscntrl(s[n]); n--)
		if(s[n] == '\n')
			s[n] = '\0';

	/* find the last space in the string */
	for (n = strlen (s) - 1; n >= 0 && isspace (s[n]); n--)
		s[n + 1] = '\0';		/* plop a null char on top of it */

	return (s);					/* return pointer to string */
}

