
#include "xref.h"

/*****************************************************************************/
void StartTempFile ()
{
	TempName = TEMPORARY_FILENAME;	/* Temporary Filename */

    if ((TempFile = fopen (TempName, "w")) == NULL) {
		fprintf (stderr, "%s: Can't open temp file!\n", ProgName);
		exit (1);
    	} /* end of if */
}  /* end of StartTempFile () */



/*****************************************************************************/
void EndTempFile ()
{
	fclose (TempFile);
}  /* end of EndTempFile () */

/*****************************************************************************/
void DumpTempFile ()
{
    int fd,
        n;
    char buff[1025];

	TempFile = Ofile;

    if ((fd = open (TempName, O_RDONLY)) == -1) {
		fprintf (stderr, "%s: can't open temp file\n", ProgName);
		exit (1);
    	}  /* end of if */

    fprintf (TempFile, "%s", printer->prt_init);
    while ((n = read (fd, buff, 1024)) != 0) {
		if (fwrite (buff, n, 1, TempFile) == -1) {
		    fprintf (stderr, "%s: write error (1)\n", ProgName);
		    exit (1);
			}  /* end of if */
    	}  /* end of while */

}  /* end of DumpTempFile () */


/*****************************************************************************/
ReadResponseFile (response_file)
    char *response_file;
{
    register char 	fpntr[80];		/* area for string to be read into */
	register char	*temp;
    register int 	i = 0;
	file_info	*fblock;

    unsigned long int total_file_size = 0;

    disk_space_2.total_bytes_free = 0;

    response_file += 2;    /* strip the "-@" from the string */

    if ((Rfile = fopen (response_file, "r")) == NULL) {
		fprintf (stderr, "Can't Open Response File %s\n", response_file);
		exit (1);	/* terminate abruptly */
		}
    else
	    {
      /* read a entire line from the Rfile that is up to 
				80 characters long */
		while (fgets (fpntr, 80, Rfile) != NULL && i < N_FILES) {

			temp = strsave (strtok (fpntr, " \n"));
			if (temp) {				/* if not Null */
		    	fname[i++] = temp;

				/* fill fblock with info */
		    	if ( !(fblock = get_file_info(fpntr)) ) {
					/* keep running total of filesizes */
			    	total_file_size += fblock->fsize; 
					} /* end of if */
				} /* end of if */

			} /* end of while */

		fclose (Rfile); 	/* and close the file */

		 /* get bytes free on disk */
		disk_information(&disk_space_1, &disk_space_2, 0);

		if ( (total_file_size * 2) >= disk_space_2.total_bytes_free) {
			fprintf (stderr, "Insufficient Disk Space!\n\
						Minimum of %lu bytes needed.\n\
						You have %lu bytes free\n",
						total_file_size * 2, disk_space_2.total_bytes_free);
			exit (1);
			} /* end of if */
	
		/* return new number of files */
		return (i);
    	}
    return (0);
} /* end of ReadResponseFile */
