#include "xref.h"

/****************************************************************************/
int PutLine (l)
	register char *l;
{
	register char c;
	int bp;
	char *save;

	bp = 0;
	for (save = expand (l); ((c = *l) != 0); ++l) {	/* bump thru the string */
		if (InComment)							/* if your in a comment */
			l = EndComment (l, &InComment);		/* process till your out */
		else {
			if (InString)						/* if your in a string */
				l = EndString (l, &InString);	/* process till your out */
			else {								/* it must be something */
				switch (c) {
					case '{' :					/* curly brace IN */
						++Braces;				/* increment brace count */
						break;

					case '}' :					/* curly brace OUT */
						if (--Braces == 0) {	/* coming out yet? */
							if (*(l + 1) == ';')	/* is it structure? */
								++l;				/* continue thru string */
							else
								if (extra_lines)	/* if option enabled */
									bp = 1;			/* flag for extra lines */
							} /* end of if */
						break;

					case '\'' :					/* Forward Slash */
						++l;					/* continue thru string */
						break;

					case '"' :					/* Quotation Mark */
						InString = 1;			/* must be in a string */
						break;

					case '/' :					/* Start of Comment */
						if (*(l + 1) == '*') {	/* is next character * ? */
							InComment = 1;		/* must be in a comment */
							++l;				/* continue thru string */
							} /* end of if */
							break;
					} /* end of switch */
				} /* end of else */
			} /* end of else */
		} /* end of for loop */

	PutLine1 (save);
	return (bp);
}

/**************************************************************************/
void PutLine1 (save)
	register char *save;				/* pointer to expanded string */
{

	int first_time = TRUE;				/* first time pass flag */
	int pos=0,							/* position in string */
		size = 0,
		offset,
		savec,							/* do I need to save a character */
		end_of_loop;				
	register char *section;				/* sub string */
	int	string_length,					/* length of working string */
		save_string_length;
	char indent[256];
	char *p;
	char Digits[15];

	if (NumLines) {							/* if line numbering enabled */
		sprintf (Digits, "[%4d]  ", Number);	/* make a string */
		size = strlen (Digits);				/* calc. its size */
		} /* end of if */
	else
		size = 0;							/* else it's size is 0 */

	save_string_length = strlen (save);
	end_of_loop = FALSE; 

	while (!end_of_loop) {
		savec = 0;
		section = substr (save, pos, PageWidth - size);
		string_length = strlen (section);

		if (string_length) {						/* if we have a string */
			if (string_length + pos >= save_string_length) {
				end_of_loop = TRUE;
				offset = string_length + 1;
				}
			else {
				if (section[string_length - 1] != ' ')
					if (NULL == (p = strrchr (section, ' '))) {
						offset = string_length;
						savec = -1;					/* back up a char */
						}
					else
						offset = p - section;
				else
					offset = string_length - 1;
				}

			section[offset] = NULL;					/* trunc section at space */

			if (first_time) {						/* if this is the first pass */
				if (NumLines)						/* if line numbering enabled */
					fprintf (TempFile, "[%4d]  %s\n", Number++, section);
				else
					fprintf (TempFile, "%s\n", section);
	
				if (!end_of_loop) {					/* do we have continue */
					/* find indention of the line */
					p = indent;
	
					while (*section == ' ') 
						*p++ = *section++;
					*p = '\0'; 
	
					strcat (indent, "    ");		/* indent 4 more spaces */
					size = strlen (indent);
					first_time = FALSE;
					} /* end of if */
				} /* end of if */
			else {							/* continuation line */
				fprintf (TempFile, "C %s%s\n", indent, section);
				if (++LineNumber > PageEnd)
					NewPage ();
				} /* end of else */
			pos += offset;		/* find new position */
											/* this must be a strlen */
			}
		else 								/* we have no string */
			end_of_loop = TRUE;

		} /* end of while */
} /* end of PutLine1() */

/**************************************************************************/
void PutHeader ()
{
	register int i,
		l;

	putc ('\n', TempFile);

	if (header_flag) {
		print_double_width ();
		l = strlen (Name) * 3;

		fprintf (TempFile, "%s", Name);		/* Write out Filename or TOC */
		normal_print ();
		}

	if (PageNumber > 0) {				/* if you're not on the TOC pages */
		for (i = (l + 7) / 8; i < 5; ++i)
			putc ('\t', TempFile);		/* Tab out for position */

		if (header_flag) {
			if (! sectionflg) {
				fprintf (TempFile, "%s\tPage: %d\n\n\n", Todayv, PageNumber);
				}
			else {
				fprintf (TempFile, "%s\tSection %3d - %d\n\n\n", Todayv, SectionNumber, PageNumber);
				}
			}

		if (header_lines)	/* Header for TOP OF PAGE */
			fprintf (TempFile, "%s", header_buffer);
		}
	else {   /* 1st line of Table of Contents page gets the time and date */
		for (i = (l + 7) / 8; i < 6; ++i)	/* Tab out for time/date */
			putc ('\t', TempFile);

		/* Todays Time and Date */
		if(header_flag)
			fprintf (TempFile, "\t\t\t\t%s\n\n", Todayv);
		else
			fprintf (TempFile, "\n\n");

		if (header_lines)	/* Header for TOP OF PAGE */
			fprintf (TempFile, "%s", header_buffer);
		}

	LineNumber += (HEADER_SIZE + header_lines);		/* bump line number counter */
}

