#include "xref.h"

/*****************************************************************************/
/*
 * Enter module list with m1 calling or using m2
 */
int store_mod_call (modlist, m1, m2)
    struct cptr *modlist[];
int m1,
	m2;
{
	struct cptr *pc,
			*cp;

	if ((pc = (struct cptr *) malloc (sizeof (struct cptr))) == NULL)
		exit (0);

	pc->next_ptr = NULL;
	pc->proc = m2;
	if (modlist[m1]) {
		cp = modlist[m1];
		do {
			if (cp->proc == m2) {
				free (pc);
				return (1);
				} /* end of if */

			if (cp->next_ptr)
				cp = cp->next_ptr;
			else
				break;
			} while (cp);

		cp->next_ptr = pc;
		} /* end of if */
	else
		modlist[m1] = pc;

	return (1);
} /* end of store_mod_call () */

/*****************************************************************************/
/*
 * Enter tree with tindex, stores proc_index and module_index in Calls
 */
int store_call (stree, tindex)
    struct tnode *stree;
    int tindex;
{
	struct cptr *pc,
		*cp;

	if (stree) {
		if (stree->this_entry->index == tindex) {
			if ((pc = (struct cptr *) malloc (sizeof (struct cptr))) == NULL)
				exit (0);
			pc->next_ptr = NULL;
			pc->proc = proc_index;
			if (stree->this_entry->calls) {
				cp = stree->this_entry->calls;
				do {
					if (cp->proc == proc_index) {
						free (pc);
						return (1);
						}  /* end of if */
					if (cp->next_ptr)
						cp = cp->next_ptr;
					else
						break;
					} while (cp);
				cp->next_ptr = pc;
				}  /* end of if */
			else
				stree->this_entry->calls = pc;

			return (1);
			} /* end of if */
		else {
			if (store_call (stree->left, tindex) == 0)
				store_call (stree->right, tindex);
			}  /* end of else */
		} /* end of if */
	return (0);
}   /* end of store_call () */

/*****************************************************************************/
/*
 * Enter tree with tindex, stores proc_index and module_index in Uses area
 */
int store_uses (stree, tindex, p)
    struct tnode *stree;
    int tindex,
        p;
{
	struct cptr *pc,
		*cp;

	if (stree) {
		if (stree->this_entry->index == tindex) {
			if ((pc = (struct cptr *) malloc (sizeof (struct cptr))) == NULL)
				exit (0);
			pc->next_ptr = NULL;
			pc->proc = p;
			if (stree->this_entry->uses) {
				cp = stree->this_entry->uses;
				do {
					if (cp->proc == p) {
						free (pc);
						return (1);
						}  /* end of if */

					if (cp->next_ptr)
						cp = cp->next_ptr;
					else
						break;
					} while (cp);
				cp->next_ptr = pc;
				} /* end of if */
			else
				stree->this_entry->uses = pc;
			return (1);
			} /* end of if */
		else {
			if (store_uses (stree->left, tindex, p) == 0)
				store_uses (stree->right, tindex, p);
			}  /* end of else */
		} /* end of if */
	return (0);
}   /* end of store_uses () */

/*****************************************************************************/
/*
 * Enter tree with tindex, returns ptr to call structure
 */
int search_call (stree, tindex, pc)
	struct tnode *stree;
	int tindex;
	struct cptr **pc;
{
	if (stree) {
		if (stree->this_entry->index == tindex) {
			*pc = stree->this_entry->calls;
			return (1);
			} /* end of if */
		else {
			if (search_call (stree->left, tindex, pc) == 0)
				search_call (stree->right, tindex, pc);
			} /* end of else */
		}
	return (0);
}  /* end of search_call () */

/*****************************************************************************/
/*
 * Enter tree with tindex, returns ptr to uses structure
 */
int search_use (stree, tindex, pc)
	struct tnode *stree;
	int tindex;
	struct cptr **pc;
{
	if (stree) {
		if (stree->this_entry->index == tindex) {
			*pc = stree->this_entry->uses;
			return (1);
			} /* end of if */
		else {
			if (search_use (stree->left, tindex, pc) == 0)
				search_use (stree->right, tindex, pc);
			} /* end of else */
		} /* end of if */
	return (0);
}  /* end of search_use () */

/****************************************************************************/
/*
 * Enter tree with tindex, returns with alfa string corresponding
 */
int searchtree_index (stree, word, tindex)
    struct tnode *stree;
    char *word;
    int tindex;
{
	if (stree) {
		if (stree->this_entry->index == tindex)	{
			strcpy (word, stree->this_entry->proc);
			module_index = stree->this_entry->module;
			return (1);
			}
		else {
			if (searchtree_index (stree->left, word, tindex) == 0)
				searchtree_index (stree->right, word, tindex);
			}
		}
	return (0);
}

/*****************************************************************************/
/*
 * enter with word, returns index
 */
int searchtree_word (stree, word, tindex)
    struct tnode *stree;
    char *word;
    int *tindex;
{
	if (stree) {
		if (stricmp (stree->this_entry->proc, word) == 0) {
			proc_index = stree->this_entry->index;
			module_index = stree->this_entry->module;
			*tindex = stree->this_entry->index;
			return (1);
			}
		else {
			if (searchtree_word (stree->left, word, tindex) == 0)
				searchtree_word (stree->right, word, tindex);
			}
		}
	return (0);
}

/*****************************************************************************/
struct tnode *entertree (stree, word, lindex, tindex)
    struct tnode *stree;
    char *word;
    int *lindex,
       *tindex;
{
	if (stree == NULL) {
		stree = (struct tnode *) malloc (sizeof (struct tnode));
		stree->this_entry = (struct entrytype *) malloc (sizeof (struct entrytype));
		stree->left = NULL;
		stree->right = NULL;
		stree->this_entry->calls = NULL;
		stree->this_entry->uses = NULL;
		stree->this_entry->proc = strsave (word);
		stree->this_entry->module = module_index;
		(*lindex)++;
		stree->this_entry->index = *lindex;
		*tindex = *lindex;
		}
	else
		switch (strcmp (stree->this_entry->proc, word)) {
			case 0:
				*tindex = stree->this_entry->index;
				break;
			case 1:
				stree->left = entertree (stree->left, word, lindex, tindex);
				break;
			default:
				stree->right = entertree (stree->right, word, lindex, tindex);
			}
	return (stree);
}
